/* 
 * CCDMOM: take a moment along an axis in an image
 *
 *	quick and dirty:  8-jun-95		pjt
 *      19-oct-95   very dirty axis=3           pjt
 *                      
 */


#include <stdinc.h>
#include <getparam.h>
#include <vectmath.h>
#include <filestruct.h>
#include <image.h>

string defv[] = {
        "in=???\n       Input image file",
	"out=???\n      Output image file",
	"axis=1\n       Axis to take moment along (1=x 2=y 3=z)",
	"mom=0\n	Moment to take [-2,-1,0,1,2,..]",
	"VERSION=0.2\n  19-oct-95 PJT",
	NULL,
};

string usage = "moment along an axis of an image";



void nemo_main()
{
    stream  instr, outstr;
    int     nx, ny, nz, nx1, ny1, nz1;
    int     axis, mom;
    int     i,j,k;
    imageptr iptr=NULL, iptr1=NULL;      /* pointer to images */
    real    tmp;

    instr = stropen(getparam("in"), "r");
    mom = getiparam("mom");
    if (mom != 0) error("non-zero moments not supported yet");
    axis = getiparam("axis");

    read_image( instr, &iptr);

    nx = Nx(iptr);	
    ny = Ny(iptr);
    nz = Nz(iptr);
    if (axis==1) {
        nx1 = 1;
        ny1 = ny;
	nz1 = nz;
    } else if (axis==2) {
        nx1 = nx;
        ny1 = 1;
        nz1 = nz;
    } else if (axis==3) {
        nx1 = nx;
        ny1 = ny;
        nz1 = 1;
    } else
        error("Invalid axis: %d (Valid: 1,2,3)",axis);
    

    outstr = stropen(getparam("out"), "w");

    create_cube(&iptr1,nx1,ny1,nz1);

    if (axis==1) {                              /* yuck: not tested */
      warning("axis=1 needs to be tested");
      for (k=0; k<nz; k++)
        for (j=0; j<ny; j++) {
            tmp = 0.0;
            for (i=0; i<nx; i++)
                tmp += MapValue(iptr,i,j);
            CubeValue(iptr1,0,j,k) = tmp / nx;
        }
    } else if (axis==2) {                       /* yuck: not tested */
      warning("axis=2 needs to be tested");
      for (k=0; k<nz; k++)
        for (i=0; i<nx; i++) {
            tmp = 0.0;
            for (j=0; j<ny; j++)
                tmp += MapValue(iptr,i,j);
            CubeValue(iptr1,i,0,k) = tmp / ny;
        }
    } else if (axis==3) {                       /* this one is tested */
    	for(j=0; j<ny; j++)
    	for(i=0; i<nx; i++) {
    	    tmp = 0.0;
    	    for(k=0; k<nz; k++)
    	        tmp += CubeValue(iptr,i,j,k);
    	    CubeValue(iptr1,i,j,0) = tmp / nz;
    	}
        Xmin(iptr1) = Xmin(iptr);
        Ymin(iptr1) = Ymin(iptr);
        Zmin(iptr1) = Zmin(iptr) + 0.5*(nz-1)*Dz(iptr);
        Dx(iptr1) = Dx(iptr);
        Dy(iptr1) = Dy(iptr);
        Dz(iptr1) = nz * Dz(iptr);
        
        Namex(iptr1) = Namex(iptr); /* care: we're passing a pointer */
        Namey(iptr1) = Namey(iptr);
        Namez(iptr1) = Namez(iptr);
        
    } else
        error("Cannot do axis %d",axis);

    write_image(outstr, iptr1);
}
