/*
 *  MAIN.C : NEMO driver for Aarseth's fortran nbody0 program
 *
 *	 3-jul-89	V1.1  
 *	23-jan-90	V1.2  ???  		PJT
 *	17-may-91	V1.2a bit more doc	PJT
 *	 6-mar-92       Happy GCC2.0		PJT
 *       6-aug-97       V1.3 options=           PJT
 */

#include <stdinc.h>

string defv[] = {
    "in=???\n       Input (snapshot) file",
    "out=???\n      Output (snapshot) file",
    "eta=0.02\n     Accuracy parameter - determines timesteps",
    "deltat=0.25\n  When to dump major output",
    "tcrit=2\n      When to stop integrating",
    "eps=0.05\n     Softening length",
    "options=\n     Optional output of 'step' into AUX",
    "VERSION=1.3\n  6-aug-97 PJT",
    NULL,
};

string usage = "NEMO driver for nbody0";

extern void pars_2_aarseth(void), 
	    call_2_aarseth(void);

/*
 *  nemo_main is the main() type entry for the program. The functions
 *  called here live in nbodyio.c, which serves as a C-to-Fortran 
 *  layer.
 */

void
nemo_main()
{
    pars_2_aarseth();       /* get parameters */
    call_2_aarseth();       /* run the code */
}

