/*
 *  NBODY:   Nemo driver to the NBODY family
 *
 *		** note: this one not finished yet, see runbody2 	
 *		   for another approach
 *
 *	Writes a script that runs a program from the Aarseth NBODY family
 *
 *?	Converts input snapshot(5) to the "205" ascii format
 *	runs the (fortran) treecode program, and converts
 *	the output data (in 205 format) back to snapshot(5)
 *	The script is then executed via execl().
 *
 *	The following executables need to be present in the
 *	searchpath:
 *	   stoa, treecode*, and atos
 *	   
 *
 * History:
 *	23-may-95	cloned off a similar program for treecode	PJT
 *	16-jun-97	fixed some typos for released version		pjt
 */

#include <stdinc.h>
#include <getparam.h>
#include <unistd.h>

string defv[] = {

                    /* NEMO parameters */

    "prog=nbody1\n          Name of NBODY1 program to run",
    "dir=.\n                Directory to run program in",

                    /* NBODY parameters */
  
    "kstart=1\n         Run mode: 1=new >1 restart",
    "n=25\n             Numer of particles",
    "nfix=1\n           Output freq in terms of deltat",
    "nrand=0\n          Random number sequence skip",
    "nrun=1\n           Run id",
    "eta=0.02\n         time step accuracy",
    "deltat=1\n         output interval, in units of crossing time",
    "tcrit=5\n          stop time, in units of crossing time",
    "qe=0.00002\n       energy tolerance",
    "eps=0.03\n        softening",
    "kz=1,0,0,0,1,1,0,0,0,0,0,0,0,0,0\n     options array",
    "alphas=2.5\n       power law for IMF",
    "body1=5\n          max particle mass (before scaling)",
    "bodyn=1\n          min particle mass (before scaling)",
    "q=0.5\n            virial ratio (0.5 = equilibrium)",
    "vxrot=0.0\n        XY-velocity scaling",
    "vzrot=0.0\n        Z-velocity scaling",
    "rbar=1.0\n         virial radius in PC (for scaling)",
    "zmbar=1.0\n        mean mass in solar units (for scaling)",
    "VERSION=1.0\n      23-may-95 PJT",
  NULL,
};

string usage="NEMO frontend run to NBODY1";

nemo_main()
{
    stream str;
    char cmd[256];
    string dir, prog;
    int i, nkz, maxkz;

    int kstart, n, nfix, nrand, nrun, kz[64];
    double tcomp, eta, deltat, tcrit, qe, eps, alphas,
           body1, bodyn, q, vxrot, vzrot, rbar, zmbar;

    prog = getparam("prog");
    dir = getparam("dir");
    if (chdir(dir)) error("Bad working directory");

    kstart = getiparam("kstart");
    tcomp = 1000.0;
    n = getiparam("n");
    nfix = getiparam("nfix");
    nrand = getiparam("nrand");
    nrun = getiparam("nrun");
    eta = getdparam("eta");
    deltat = getdparam("deltat");
    tcrit = getdparam("tcrit");
    qe = getdparam("qe");
    eps = getdparam("eps");
    maxkz = 15;
    nkz = nemoinpi(getparam("kz"),kz,maxkz);
    if (nkz<0) error("Parsing kz=");
    alphas = getdparam("alphas");
    body1 = getdparam("body1");
    bodyn = getdparam("bodyn");
    q = getdparam("q");
    vxrot = getdparam("vxrot");
    vzrot = getdparam("vzrot");
    rbar = getdparam("rbar");
    zmbar  = getdparam("zmbar");

    sprintf(cmd,"%s.in",prog);
    str = stropen(cmd,"w");

    /* NBODY1 */

    fprintf(str,"%d %g\n",kstart,tcomp);
    fprintf(str,"%d %d %d %d\n",n,nfix,nrand,nrun);
    fprintf(str,"%g %g %g %g %g\n",eta,deltat,tcrit,qe,eps);
    for (i=0; i<maxkz; i++)
        fprintf(str,"%d ", i<nkz ? kz[i] : 0);
    fprintf(str,"\n");
    fprintf(str,"%g %g %g\n",alphas,body1,bodyn);
    fprintf(str,"%g %g %g %g %g\n",q,vxrot,vzrot,rbar,zmbar);

    strclose(str);

    sprintf(cmd,"%s < %s.in > %s.out",prog,prog,prog);

    system(cmd);
}
